package com.sun.corba.se.impl.ior;

import com.sun.corba.se.spi.ior.IdentifiableFactoryFinder;
import org.omg.CORBA_2_3.portable.InputStream;
import org.omg.CORBA_2_3.portable.OutputStream;
import java.util.Iterator;
import com.sun.corba.se.spi.ior.TaggedProfileTemplate;
import com.sun.corba.se.spi.ior.IORFactory;
import com.sun.corba.se.spi.ior.IOR;
import com.sun.corba.se.spi.ior.ObjectId;
import com.sun.corba.se.spi.orb.ORB;
import com.sun.corba.se.spi.ior.ObjectKeyTemplate;
import com.sun.corba.se.spi.ior.IORTemplate;
import com.sun.corba.se.spi.ior.IdentifiableContainerBase;

public class IORTemplateImpl extends IdentifiableContainerBase implements IORTemplate
{
    private ObjectKeyTemplate oktemp;
    
    public boolean equals(Object o) {
        if (o == null) {
            return false;
        }
        if (!(o instanceof IORTemplateImpl)) {
            return false;
        }
        IORTemplateImpl iorTemplateImpl = (IORTemplateImpl)o;
        return super.equals(o) && this.oktemp.equals(iorTemplateImpl.getObjectKeyTemplate());
    }
    
    public int hashCode() {
        return super.hashCode() ^ this.oktemp.hashCode();
    }
    
    public ObjectKeyTemplate getObjectKeyTemplate() {
        return this.oktemp;
    }
    
    public IORTemplateImpl(ObjectKeyTemplate oktemp) {
        this.oktemp = oktemp;
    }
    
    public IOR makeIOR(ORB orb, String s, ObjectId objectId) {
        return new IORImpl(orb, s, this, objectId);
    }
    
    public boolean isEquivalent(IORFactory iorFactory) {
        if (!(iorFactory instanceof IORTemplate)) {
            return false;
        }
        IORTemplate iorTemplate = (IORTemplate)iorFactory;
        Iterator<Object> iterator = this.iterator();
        Iterator<Object> iterator2 = iorTemplate.iterator();
        while (iterator.hasNext() && iterator2.hasNext()) {
            if (!((TaggedProfileTemplate)iterator.next()).isEquivalent((TaggedProfileTemplate)iterator2.next())) {
                return false;
            }
            continue;
        }
        return iterator.hasNext() == iterator2.hasNext() && this.getObjectKeyTemplate().equals(iorTemplate.getObjectKeyTemplate());
    }
    
    public void makeImmutable() {
        this.makeElementsImmutable();
        super.makeImmutable();
    }
    
    public void write(OutputStream outputStream) {
        this.oktemp.write(outputStream);
        EncapsulationUtility.writeIdentifiableSequence(this, outputStream);
    }
    
    public IORTemplateImpl(InputStream inputStream) {
        ORB orb = (ORB)(ORB)inputStream.orb();
        IdentifiableFactoryFinder taggedProfileTemplateFactoryFinder = orb.getTaggedProfileTemplateFactoryFinder();
        this.oktemp = orb.getObjectKeyFactory().createTemplate(inputStream);
        EncapsulationUtility.readIdentifiableSequence(this, taggedProfileTemplateFactoryFinder, inputStream);
        this.makeImmutable();
    }
}
